require "paperclip"

module Paperclip
  class PaperCropper < Thumbnail
    def transformation_command
      if crop_command
        crop_command + super.join(' ').sub(/ -crop \S+/, '').split(' ')
      else
        super
      end
    end

    def crop_command
      target = @attachment.instance

      if target.cropping?(@attachment.name)
        begin
          x = Integer(target.send :"#{@attachment.name}_crop_x")
          y = Integer(target.send :"#{@attachment.name}_crop_y")
          w = Integer(target.send :"#{@attachment.name}_crop_width")
          h = Integer(target.send :"#{@attachment.name}_crop_height")
          ["-crop", "#{w}x#{h}+#{x}+#{y}"]
        rescue Exception => e
          ::PaperCropper.log("[paper_cropper] #{@attachment.name} crop w/h/x/y were non-integer. Error: #{e.to_s}")
          return
        end
      end
    end

  end
end
